package cn.net.connor.createTempDrawings.dialogs;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.Label;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.text.SimpleDateFormat;
import java.util.*;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.mail.Folder;
import javax.swing.*;
import javax.swing.tree.DefaultMutableTreeNode;

import org.apache.log4j.LogManager;
import org.apache.log4j.Logger;

import com.teamcenter.rac.aif.AbstractAIFApplication;
import com.teamcenter.rac.aif.AbstractAIFDialog;
import com.teamcenter.rac.aif.kernel.InterfaceAIFComponent;
import com.teamcenter.rac.kernel.ListOfValuesInfo;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentFolder;
import com.teamcenter.rac.kernel.TCComponentForm;
import com.teamcenter.rac.kernel.TCComponentItem;
import com.teamcenter.rac.kernel.TCComponentItemRevision;
import com.teamcenter.rac.kernel.TCComponentItemType;
import com.teamcenter.rac.kernel.TCComponentListOfValues;
import com.teamcenter.rac.kernel.TCException;
import com.teamcenter.rac.kernel.TCPreferenceService;
import com.teamcenter.rac.kernel.TCProperty;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.util.DateButton;
import com.teamcenter.rac.util.MessageBox;
import com.teamcenter.rac.util.PropertyLayout;
import com.teamcenter.rac.util.UIUtilities;
import com.teamcenter.schemas.soa._2006_03.exceptions.ServiceException;
import com.teamcenter.services.rac.core.DataManagementService;
import com.teamcenter.services.rac.core.LOVService;
import com.teamcenter.services.rac.core._2008_06.DataManagement.CreateIn;
import com.teamcenter.services.rac.core._2008_06.DataManagement.CreateInput;
import com.teamcenter.services.rac.core._2008_06.DataManagement.CreateOut;
import com.teamcenter.services.rac.core._2008_06.DataManagement.CreateResponse;
import com.teamcenter.services.rac.core._2013_05.LOV.InitialLovData;
import com.teamcenter.services.rac.core._2013_05.LOV.LOVSearchResults;
import com.teamcenter.services.rac.core._2013_05.LOV.LOVValueRow;
import com.teamcenter.services.rac.core._2013_05.LOV.LovFilterData;
import com.teamcenter.soaictstubs.BooleanHolder;
import com.teamcenter.soaictstubs.ICCTItem;
import com.teamcenter.soaictstubs.StringHolder;

import cn.net.connor.createTempDrawings.pojo.LovProperty;
import cn.net.connor.createTempDrawings.utils.JTreeComboBox;
import cn.net.connor.createTempDrawings.utils.TCLOVUtil;

public class CreateTempDrawingDialog extends JFrame implements ActionListener{
	private static final Logger logger = LogManager.getLogger(CreateTempDrawingDialog.class);
	
	private AbstractAIFApplication application;
	private TCSession tcSession ;
	private InterfaceAIFComponent selectComponent;
	private JLabel drawingObjTypeLabel;//ͼֽͱǩ
	private JComboBox<String> drawingObjTypeComboBox;//ͼֽ
	private JButton okButton;//ȷϰť
	private JButton button1;//ť
	private JButton button2;//ť
	private List<String> drawingObjTypeInfos = new ArrayList<String>();//ѡõĶϢ
	private JFrame buildFram;
	private String currentChoosePropPreferenceName;//ǰѡ͵
	private JLabel idLabel;
	private JTextField idTextField;
	private JLabel revLabel;
	private JComboBox<String> revComboBox;
	private List<String> showPropsInfoList = new ArrayList<>();
	private JButton closeButton;
	private JButton buildButton;
	private TCComponentItemType tccomponentitemtype;
	// ڸʽ
	private SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
	/**
	 * ѡеĶͣȡͶӦѡõϢ
	 * 磺*=Item.object_name=string
	 * ע⣺ѡõϢУģõİ汾ţʱ;
	 */
	private List<String> preferencePropList = new ArrayList<>();

	/**
	 * 
	 * ʾĿ
	 */
	private Map<String,JComponent> propComponentMap = new HashMap<>();

	/**
	 * lovԶ
	 */
	private List<LovProperty> lovPropertyList = new ArrayList<>();

	/**
	 * רڴlovmap
	 * @key:lovʵֵlovƣ
	 * @Value:lovʾֵ-ʵֵ
	 */
	private static Map<String, Map<String, String>> rMap = new HashMap<String, Map<String,String>>();

	public static void printRMap() {
//		System.out.println("begin ӡrMap");
		for (Map.Entry<String, Map<String, String>> outerEntry : rMap.entrySet()) {
			String key = outerEntry.getKey();
			Map<String, String> innerMap = outerEntry.getValue();

//			System.out.println("Key: " + key);
			for (Map.Entry<String, String> innerEntry : innerMap.entrySet()) {
//				System.out.println(">>> Inner Key: " + innerEntry.getKey() + ", Value: " + innerEntry.getValue());
			}
		}
	}

	/**
	 * ๹캯
	 * @param application
	 * @param selectComponent
	 */
	public CreateTempDrawingDialog(AbstractAIFApplication application, InterfaceAIFComponent selectComponent) {
		logger.info("haihaihai");
		try {
			this.application = application;
			this.tcSession = (TCSession) this.application.getSession();
			this.selectComponent = selectComponent;
			
			System.out.println("ʼشʱͼֽ壡");
			logger.info("ʼشʱͼֽ壡");
			List<String> list1 = getPreferenceInfos("SB6_Create_LS_Design");
			if (list1.isEmpty() || list1.size() <= 0) {
				MessageBox.post("ȡѡSB6_Create_LS_DesignϢʧܣǷȷ" , "ʾ", MessageBox.INFORMATION);
				return;
			}else {
				if (this.drawingObjTypeInfos != null && this.drawingObjTypeInfos.size() > 0) {
					this.drawingObjTypeInfos.clear();
				}
				this.drawingObjTypeInfos.addAll(list1);
			}
			initUI();
		} catch (Exception e) {
			e.printStackTrace();
		}
		
	}

	/**
	 * ѡƻȡѡϢ
	 * @param preferenceName ѡ
	 * @return List<String>
	 */
	public List<String> getPreferenceInfos(String preferenceName) {
		List<String> drawingObjPropInfosList = new ArrayList<>();
		TCPreferenceService preferenceService = tcSession.getPreferenceService();
		String[] values = preferenceService.getStringValues(preferenceName);
		if (values != null && values.length > 0) {
			for (int i = 0; i < values.length; i++) {
				drawingObjPropInfosList.add(values[i]);
			}
		}else {
			System.out.println("ȡѡ["+preferenceName+"]ϢʧܣǷȷ");
		}
		System.out.println("ȡѡ["+preferenceName+"]е["+values.length+"]Ϣ");
		return drawingObjPropInfosList;

	}

	/**
	 * ʱͼֽ-ѡ͵Ŀ
	 */
	private void initUI() throws Exception {
		this.setTitle("ѡͼֽ");
		this.setSize(400, 500);
        this.setLayout(new BorderLayout());

        JPanel centerPanel = new JPanel(new GridBagLayout());
		JPanel buttomPanel = new JPanel(new FlowLayout());
		
		this.drawingObjTypeLabel = new JLabel("ͼֽ		");
		//ȡͼֽ
		List<String> typList = getDrawingObjTypeShowName();
		if (typList.isEmpty() || typList.size() <= 0) {
			System.out.println("ȡͼֽʧܣѡǷȷ");
			return;
		}
		String[] drawingTypes = typList.toArray(new String[0]);
		this.drawingObjTypeComboBox = new JComboBox<String>(drawingTypes);
		drawingObjTypeComboBox.setPreferredSize(new Dimension(200, drawingObjTypeComboBox.getPreferredSize().height));
		drawingObjTypeComboBox.setEditable(false);

		GridBagConstraints gbc = new GridBagConstraints();
		gbc.gridx = 0;
		gbc.gridy = 0;
		gbc.anchor = GridBagConstraints.WEST;
		gbc.insets = new Insets(0, 0, 0, 12); // ұ 10 صļ
		centerPanel.add(this.drawingObjTypeLabel, gbc);

		gbc.gridx = 1;
		centerPanel.add(drawingObjTypeComboBox, gbc);

		this.okButton = new JButton("ȷ");
		buttomPanel.add(okButton);
		

		//
		this.add(centerPanel, BorderLayout.CENTER);
		this.add(buttomPanel, BorderLayout.SOUTH);
		
		
		//ťʱ
		this.okButton.addActionListener(this);
		
		

		this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		this.setResizable(true);
  		this.setPreferredSize(new Dimension(800,600));
  		this.pack(); // ԶڴСӦڲ

		//ŵĻ
		UIUtilities.centerToScreen(this);
		
		this.setVisible(true);
		this.revalidate();
		this.repaint();

	}
	
	public String getSourceValue(String[] split) throws TCException {
		String value = null;
		if (split.length == 4) {//ϢУڼ̳Դ
			String propSource = split[3];
			String[] sourceArr = propSource.split("\\.");
			if (sourceArr.length > 0) {
				String sourceLocation = sourceArr[0];
				String sourceTrueName = sourceArr[1];
				
				
				if (this.selectComponent instanceof TCComponentItemRevision) {
					TCComponentItemRevision itemRevision = (TCComponentItemRevision) selectComponent;
					TCComponentItem item = itemRevision.getItem();
					if (sourceLocation.equals("Item")) {
						value = item.getStringProperty(sourceTrueName);
					}else if (sourceLocation.equals("Rev")) {
						value = itemRevision.getStringProperty(sourceTrueName);
					}else if (sourceLocation.equals("Form")) {
						// ȡ汾
						TCComponentForm form = (TCComponentForm) itemRevision.getRelatedComponent("IMAN_master_form_rev");
						if (form != null) {
							value = form.getStringProperty(sourceTrueName);
						}
					}
					
				}else {
					System.out.println("ѡжļУ޷ȡֵ̳");
				}
			}
			
		}
		return value;
	}
	
	/**
	 * 
	 * @throws Exception 
	 */
	public void createItem() throws Exception {
//		Map<String, String> formMap = new HashMap<String, String>();
		//ʵֵֵ(string\date\lov:lovname)
		List<String[]> formList = new ArrayList<String[]>();
		CreateIn itemDef = new CreateIn();
		CreateInput itemRevisionDef = new CreateInput();
		//ȡ
		List<String> typeList = this.drawingObjTypeInfos;//ѡõϢ
		if (typeList == null || typeList.size() <= 0) {
			System.out.println("ͻȡ쳣ʱͼֽʧܣ");
			return;
		}
		String itemType = null;
		String item_id = null;
		String item_revision_id = null;
		String chooseType = (String) this.drawingObjTypeComboBox.getSelectedItem();
		for (String string : typeList){
			String[] types = string.split("=");
			if (chooseType.equals(types[0])) {
				itemType = types[1];
				break;
			}
		}
		System.out.println("½ͼֽΪ"+itemType);
		//ȡͰ汾id
		for (Map.Entry<String, JComponent> entry : this.propComponentMap.entrySet()) {
			String key = entry.getKey();
			if (key.equals("ID*")){
				item_id = getComponentValue(key,entry.getValue());
			} else if (key.equals("汾")) {
				item_revision_id = getComponentValue(key,entry.getValue());//item_revision_id
			}
		}


		//item
		itemDef.data.boName = itemType;
		itemDef.data.stringProps.put("item_id", item_id);

		//汾
		itemRevisionDef.boName = itemType + "Revision";
		if (item_revision_id != null) {
			itemRevisionDef.stringProps.put("item_revision_id", item_revision_id);
		}else {
			System.out.println("ȡ汾idʧܣ󴴽ʧܣ");
			return;
		}
		

//		System.out.println("Ŀ-="+this.propComponentMap.size());
		for (Map.Entry<String, JComponent> entry : this.propComponentMap.entrySet()) {
			String key = entry.getKey();//༭Ŀ
			String value = getComponentValue(key,entry.getValue());//ȡѡСֵ
			int tag = 0;
			//ѡãȡʵֵλá͵Ϣ
			for (int i = 1; i < preferencePropList.size(); i++){
				String prop = preferencePropList.get(i);
				String[] split = prop.split("=");
				if (split != null && split.length > 0) {
					String propName = split[0];
					String s1 = split[1];
					String[] split2 = s1.split("\\.");
					String location = null;
					String trueName = null;
					if (split2.length>0) {
						location = split2[0];//Item/Rev/Form
						trueName = split2[1];//ʵ
					}else {
						System.out.println("ѡõϢ"+split[1]+"쳣.ţ");
					}
					String typeString = split[2];
					String configName = removeAsterisk(propName);
					String showName = removeAsterisk(key);
					if (configName.equals(showName)) {
						tag++;
						System.out.println("ʼֵԣ"+propName+"Ӧֵ"+value);
						//жǷҪ̳УҪĻȡֵ̳
						String sourceValue = getSourceValue(split);
						if (sourceValue != null) {
							System.out.println("Ҫȡֵ̳"+sourceValue);
							value = sourceValue;
						}
						System.out.println(propName+"=>"+value);
						
						if (location.equals("Item")) {
							if (typeString.equals("string")) {
								itemDef.data.stringProps.put(trueName, value);
							}else if (typeString.equals("date")) {
								SimpleDateFormat sdf = new SimpleDateFormat("yyyy-M-dd HH:mm");
								Date date = sdf.parse(value);
								Calendar calendar = Calendar.getInstance();
					            calendar.setTime(date);
								itemDef.data.dateProps.put(trueName, calendar);
							}else if (typeString.split(":")[0].equals("lov")) {
								String trueValue = getLovTrueValue(trueName,value,this.lovPropertyList);
								System.out.println("ԣ"+propName+"ոֵ"+trueValue);
								itemDef.data.stringProps.put(trueName, trueValue);
							}
						}else if (location.equals("Rev")) {
							if (typeString.equals("string")) {
								itemRevisionDef.stringProps.put(trueName, value);
							}else if (typeString.equals("date")) {
								SimpleDateFormat sdf = new SimpleDateFormat("yyyy-M-dd HH:mm");
								Date date = sdf.parse(value);
								Calendar calendar = Calendar.getInstance();
					            calendar.setTime(date);
					            itemRevisionDef.dateProps.put(trueName, calendar);
							}else if (typeString.split(":")[0].equals("lov")) {
								String trueValue = getLovTrueValue(trueName,value,this.lovPropertyList);
								System.out.println("ԣ"+propName+"ոֵ"+trueValue);
								itemRevisionDef.stringProps.put(trueName, trueValue);
							}
						}else if (location.equals("Form")) {
							//˴Աʱֵݴ浽һMap
//							itemRevisionDef.stringProps.put(trueName, value);
							String[] formPropInfos = {trueName, value, typeString};//ʵƣorѡеֵ(string\date\lov:lovname)
							formList.add(formPropInfos);
						}else {
							System.out.println("ѡ֮λá");
						}
					}else {
						continue;
					}
				}else {
					System.out.println("ѡõϢ"+prop+"쳣(=)");
				}
				
			}
			if (tag == 0) {
				System.out.println("Ŀ["+key+"]δѡҵӦ");
			}
		}
		
		System.out.println("0");

		itemDef.data.compoundCreateInput.put("revision", new CreateInput[] { itemRevisionDef });

		DataManagementService dmService = DataManagementService.getService(tcSession);
		CreateResponse createObjResponse = dmService.createObjects(new CreateIn[] { itemDef });

		if (createObjResponse.serviceData.sizeOfPartialErrors() == 0) {
		    for (CreateOut out : createObjResponse.output) {
		        for (TCComponent obj : out.objects) {
		            TCComponentItem item;
					TCComponentItemRevision itemRev;
					TCComponentForm form;
					if (obj instanceof TCComponentItem) {
						item = (TCComponentItem) obj;
						item.lock();
						try {
							System.out.println("ʼ½ʱͼֽѡж");
							if (this.selectComponent instanceof TCComponentFolder) {
								System.out.println("ضļ");
								TCComponentFolder folder = (TCComponentFolder) this.selectComponent;
								folder.add("contents", item);
							}else if (this.selectComponent instanceof TCComponentItemRevision) {
								TCComponentItemRevision revision = (TCComponentItemRevision) this.selectComponent;
								revision.add("SB6_LSSJRelation", item);
								
							}
							
						} catch (Exception e) {
							System.out.println("item쳣");
							e.printStackTrace();
						}finally {
							item.save();
							item.unlock();
						}
					}
		            else if (obj instanceof TCComponentItemRevision) {
		            	itemRev = (TCComponentItemRevision) obj;
						String[] formPropInfos = {"sb6_ifls","","lov"};
						formList.add(formPropInfos);
		            	if (!setFormProperty(itemRev,formList)) {
							System.out.println("ʧܣ");
						}
		            }
		            else if (obj instanceof TCComponentForm) {
		            	form = (TCComponentForm) obj;

		            }
		                
		        }
		    }
		}
	}

	/**
	 * 	ʵlovԼgetӦlov - ͨlovʾֵȡlovӦʵֵ
	 * @param configName ʵ
	 * @param lovShowName lovʾֵ
	 * @param lovPropertyList2 lovԼ
	 * @return lovʵֵ
	 */
	private String getLovTrueValue(String configName, String lovShowName, List<LovProperty> lovPropertyList2) {
		//жǷЧ
		if (configName == null || lovShowName == null || lovPropertyList2 == null){
			System.out.println("getLovTrueValueЧ");
			return null;
		}
		String trueNameString = null;
		//ͨlovԼϱȡlovʵֵ
		//1.ȸͨһ㣩lovͶ̬lovֱȡlovʵֵ
		for (LovProperty lovProperty : lovPropertyList2) {
			String propName = lovProperty.getPropTrueName();
			String lovType = lovProperty.getLovType();
			if (configName.equals(propName)) {//ʵlovԼƥ
				if (lovType.equals("LOV")){//ͨlovȡֵ
					Map<String, String> lovMap = lovProperty.getLovMap();
					trueNameString = lovMap.get(lovShowName);
				}else if (lovType.equals("DLOV")){//̬lovȡֵȡlovʾֵɣkey-valueṹ
					trueNameString = lovShowName;
				}

				break;
			}
		}
		//2.δȡɹͨlov㣩ϱȡlovʵֵ
		if (trueNameString == null && rMap != null && rMap.size()>0){
			for (Map.Entry<String, Map<String, String>> entry : rMap.entrySet()){
				Map<String, String> childLovMaps = entry.getValue();//ȡlovʾֵ-ʵֵ
				if (childLovMaps != null && childLovMaps.size()>0){
					for (Map.Entry<String, String> entry1 : childLovMaps.entrySet()){
						String showValueString = entry1.getKey();
						String realValueString = entry1.getValue();
						if (lovShowName.equals(showValueString)) {
							trueNameString = realValueString;

							break;
						}
					}
				}
			}
		}
		if (trueNameString == null) {
			System.out.println("δȡlov-[" + lovShowName + "]ʵֵ");
		}
		return trueNameString;
	}

	/**
	 * Ϊ
	 * @param component
	 * @param formList
	 * @return
	 */
	private boolean setFormProperty(TCComponent component, List<String[]> formList) {
		try {
			TCComponentForm form = (TCComponentForm) component.getRelatedComponent("IMAN_master_form_rev");
			form.lock();
			try {
				if (formList.size()>0) {
					System.out.println("ʼ");
					for (String[] forms : formList) {
						String finalPropValue = null;
						if (forms.length == 3) {
							String tNameString = forms[0];//ʵ
							String tValueString = forms[1];//orѡֵ
							String tTypeString = forms[2];//string/data/lov:*
							if (tTypeString.contains("lov")) {
								finalPropValue = getLovTrueValue(tNameString,tValueString,this.lovPropertyList);
							}else {
								finalPropValue = tValueString;
							}
							

							System.out.println("ñ["+tNameString+"]="+finalPropValue);
							setTCPropertyValue(form,tNameString,finalPropValue);
						}
					}
					System.out.println("Ըֵɣ");
				}else {
					System.out.println("ûҪֵıԣ");
				}
				return true;
			} catch (Exception e) {
				System.out.println("쳣");
				e.printStackTrace();
			}finally {
				form.save();
				form.unlock();
			}
		} catch (TCException e) {
			e.printStackTrace();
		}
		
		
		
		
		return false;
		
	}

	/**
	 * 
	 * @Title: setTCPropertyValue
	 * @Description: ݶֵ
	 * @param @param item
	 * @param @param propertyName
	 * @param @param value 
	 * @return void 
	 * @throws
	 */
	public static void setTCPropertyValue(TCComponent item, String propertyName, Object value) {
	    try {
	    	String type2 = item.getType();
	        TCProperty tcProperty = item.getTCProperty(propertyName);
	        String name = item.getUid();
	        if (tcProperty == null) {
				System.out.println(""+name+"ͣ"+type2+"вԣ"+propertyName);
				return;
			}
	        switch (tcProperty.getPropertyType()) {
	        case TCProperty.PROP_double:
	            if (value instanceof Double) {
	                tcProperty.setDoubleValue((double) value);
	            } else {
	                tcProperty.setDoubleValue(Double.parseDouble(value.toString()));
	            }
	            break;
	        case TCProperty.PROP_int:
	            if (value instanceof Integer) {
	                tcProperty.setDoubleValue((int) value);
	            } else {
	                tcProperty.setDoubleValue(Integer.parseInt(value.toString()));
	            }
	            break;
	        case TCProperty.PROP_string:
	            tcProperty.setStringValue(value.toString());
	            break;
	        case TCProperty.PROP_long_string:
	            tcProperty.setStringValueArray((String[]) value);
	            break;
	        case TCProperty.PROP_date:
	            if (value instanceof Date) {
	                tcProperty.setDateValue((Date) value);
	            } else {
	                SimpleDateFormat sdf = new SimpleDateFormat("yyyy-M-dd HH:mm");
	                tcProperty.setDateValue(sdf.parse(value.toString()));
	            }
	            break;
	        default:
	            break;
	        }

	    } catch (Exception e) {
	        e.printStackTrace();
	    }
	}
	

	/**
	 * ȡʱͼֽʱѡͽƼ
	 * @return List<String>
	 */
	private List<String> getDrawingObjTypeShowName() {
		List<String> drawingObjTypeList = new ArrayList<>();
		if (this.drawingObjTypeInfos != null && this.drawingObjTypeInfos.size() > 0){
			for (int i = 0; i < this.drawingObjTypeInfos.size(); i++) {
				String drawingObjTypeInfo = this.drawingObjTypeInfos.get(i);
				String[] drawingObjTypeInfoArray = drawingObjTypeInfo.split("=");
				if (drawingObjTypeInfoArray.length == 3) {//õϢֻ=
					drawingObjTypeList.add(drawingObjTypeInfoArray[0]);
				}else{
					System.out.println("Ϣ["+drawingObjTypeInfo+"]ʽȷѡǷȷ");
				}
			}
		}

		return drawingObjTypeList;
	}

	/**
	 * ȡѡеͼֽͶӦѡ
	 * @return
	 */
	private String getSelectTypePreferenceName() {
		String returnValue = null;
		//ǰѡеͼֽ
		String chooseType1 = (String) this.drawingObjTypeComboBox.getSelectedItem();

		List<String> drawingObjTypeList = new ArrayList<>();
		if (this.drawingObjTypeInfos != null && this.drawingObjTypeInfos.size() > 0){
			for (int i = 0; i < this.drawingObjTypeInfos.size(); i++) {
				String drawingObjTypeInfo = this.drawingObjTypeInfos.get(i);
				String[] drawingObjTypeInfoArray = drawingObjTypeInfo.split("=");
				if (drawingObjTypeInfoArray.length == 3) {//õϢֻ=
					//
					String typeName = drawingObjTypeInfoArray[0];
					if (chooseType1 != null && typeName != null){
						if (chooseType1.equals(typeName)) {
							returnValue = drawingObjTypeInfoArray[2];
							break;
						}
					}
				}else{
					System.out.println("Ϣ["+drawingObjTypeInfo+"]ʽȷѡǷȷ");
				}
			}
		}

		return returnValue;
	}
	
	

	@Override
	public void actionPerformed(ActionEvent e) {
		Object s = e.getSource();
		try {
			if (s.equals(this.okButton)) {
				String chooseType = (String) this.drawingObjTypeComboBox.getSelectedItem();
				System.out.println("ǰѡͼֽ="+chooseType);
				// رյǰ
				this.dispose();
				try {
					buildDrawingObjTypeFrame();
				} catch (Exception e2) {
					e2.printStackTrace();
				}
				
			}else if (s.equals(this.closeButton)) {
				System.out.println("رաť");
				// ر½
				this.buildFram.dispose();
			}else if (s.equals(this.buildButton)) {
				System.out.println("½ť");
				// У
				if(!checkRequiredProp()){
					System.out.println("Уδͨ");
					return ;
				}
				System.out.println("Уͨ");
				try {
					createItem();
				} catch (Exception e2) {
					e2.printStackTrace();
				}
				
				System.out.println("ʱͼֽɣ");
				// ر½
				this.buildFram.dispose();
			}

			 
		} catch (Exception e2) {
			e2.printStackTrace();
		}
			
		
	}

	

	/**
	 * Уԣʾ
	 * @return
	 */
	private boolean checkRequiredProp() {
//		 System.out.println("propComponentMap.size="+propComponentMap.size());
		if (propComponentMap.size()>0) {
			for (Map.Entry<String, JComponent> entry : propComponentMap.entrySet()) {
				String key = entry.getKey();
				Object value = getComponentValue(key,entry.getValue());
//				System.out.println("ʼУԣ"+key);
				if (key.contains("*")) {
//					System.out.println("ԡ"+key+"ѡ");
					if (value == null || value.equals("")) {
						MessageBox.post("ԡ"+key+"Ϊգ" , "ʾ", MessageBox.INFORMATION);
						return false;
					}
				}
				
				System.out.println(">>>"+key + ": " + value);
			}
		}
		
		return true;
	}

	/**
	 *
	 * ݲͬ͵ȡֵ
	 * @param propShowName Ŀڿչʾ
	 * @param component ĿӦ
	 * @return
	 */
	public String getComponentValue(String propShowName, JComponent component) {
		System.out.println("ʼݲͬ͵ȡֵ");
		if (component instanceof JTextField) {
			System.out.println("JTextField");
			return ((JTextField) component).getText();
		} else if (component instanceof JComboBox) {
			//ͨʾжϸǷlov
			String lovType = null;
			for (LovProperty lovProperty : this.lovPropertyList) {
				if (lovProperty.getPropName().equals(propShowName)) {
					lovType = lovProperty.getLovType();

					break;
				}
			}
			System.out.println(""+propShowName+"lovtype="+(lovType == null ? "lov" : lovType));
			String chooseDisplay= null;
			if (component instanceof JTreeComboBox){
				System.out.println("JTreeComboBox");
				JTreeComboBox  treeComboBox = (JTreeComboBox) component;
				DefaultMutableTreeNode selectedNode = (DefaultMutableTreeNode) treeComboBox.getSelectedItem();
				
				if (selectedNode != null) {
					Object userObject = selectedNode.getUserObject();
					chooseDisplay = userObject.toString();
				}else {
					System.out.println("ѡнڵselectedNode = null");
				}
			} else {
				System.out.println("JComboBox");
				JComboBox<String> comboBox = (JComboBox<String>) component;
				chooseDisplay = (String)comboBox.getSelectedItem();
			}
			return chooseDisplay;
		}else if (component instanceof DateButton) {
			System.out.println("DateButton");
			DateButton dateButton = (DateButton) component;
			Date date = dateButton.getDate();
			if (date == null){
				return null;
			}
			String dateInput = dateFormat.format(date).replaceAll("(\\d{4})-0(\\d)-", "$1-$2-") + " 00:00";
			System.out.println("dateInput="+dateInput);
			return dateInput;
		}else {
			System.out.println("֮");
		}
		return null;
	}
	

	/**
	 * ƶ͵ĴԻ
	 * @return
	 * @throws Exception 
	 */
	public JFrame buildDrawingObjTypeFrame() throws Exception{
		System.out.println("ͼֽ棡");
		this.propComponentMap.clear();
		this.lovPropertyList.clear();
		this.preferencePropList.clear();

		// ½
		JFrame frame = new JFrame();
		frame.setTitle("ʱͼֽ");
		this.setSize(400, 500);
        this.setLayout(new BorderLayout());

        JPanel centerPanel1 = new JPanel(new GridBagLayout());
		JPanel buttomPanel1 = new JPanel(new FlowLayout());

		//1.Ŀ
		this.idLabel = new JLabel("ID*");
		String idValue = getIdValue(this.selectComponent);

		if (idValue != null){
			this.idTextField = new JTextField(idValue);
		}
		

//
		// ID Label
		GridBagConstraints gbcIdLabel = new GridBagConstraints();
		gbcIdLabel.gridx = 0;
		gbcIdLabel.gridy = 0;
		gbcIdLabel.anchor = GridBagConstraints.WEST;
		gbcIdLabel.insets = new Insets(5, 5, 5, 5);
		centerPanel1.add(this.idLabel, gbcIdLabel);

		// ID TextField
		GridBagConstraints gbcIdField = new GridBagConstraints();
		gbcIdField.gridx = 1;
		gbcIdField.gridy = 0;
		gbcIdField.anchor = GridBagConstraints.WEST;

		// Զ
		Dimension textFieldSize = new Dimension(200, idTextField.getPreferredSize().height); // 200ΪĿ
		idTextField.setPreferredSize(textFieldSize);

		centerPanel1.add(this.idTextField, gbcIdField);
		propComponentMap.put("ID*", idTextField);

		String preferenceName = getSelectTypePreferenceName();
		int propIndex  = 1;
		if (preferenceName != null){
			List<String> preferenceInfoList = getPreferenceInfos(preferenceName);
			if (preferenceInfoList != null && preferenceInfoList.size()>0) {
				System.out.println("ȡѡ["+preferenceName+"]еóɹ");
				this.preferencePropList = preferenceInfoList;
			}else {
				MessageBox.post("ȡѡ"+preferenceName+"ϢʧܣǷȷ" , "ʾ", MessageBox.INFORMATION);
				return null;
			}
			
			System.out.println("õ = "+this.preferencePropList.size());
			String[] revIDs = this.preferencePropList.get(0).split(";");//汾
			
			if (revIDs != null && revIDs.length > 0) {
				this.revLabel = new JLabel("汾");
				this.revComboBox = new JComboBox<String>(revIDs);
				// 汾 Label
				GridBagConstraints gbcRevLabel = new GridBagConstraints();
				gbcRevLabel.gridx = 0;
				gbcRevLabel.gridy = 1;
				gbcRevLabel.anchor = GridBagConstraints.WEST;
				gbcRevLabel.insets = new Insets(5, 5, 5, 5);
				centerPanel1.add(this.revLabel, gbcRevLabel);

				// 汾 ComboBox
				GridBagConstraints gbcRevCombo = new GridBagConstraints();
				gbcRevCombo.gridx = 1;
				gbcRevCombo.gridy = 1;
				gbcRevCombo.anchor = GridBagConstraints.WEST;

				// Զ
				Dimension comboBoxSize = new Dimension(200, revComboBox.getPreferredSize().height); // 200ΪĿ
				revComboBox.setPreferredSize(comboBoxSize);

				centerPanel1.add(this.revComboBox, gbcRevCombo);
				propComponentMap.put("汾", revComboBox);
				
				propIndex ++;
			}
			
			
//			ѡõpreferencePropListУһǰ汾飬ԴӵڶϢʼȾ
			for (int i = 1; i < this.preferencePropList.size(); i++) {
				String propInfo = this.preferencePropList.get(i);//propInfoʽΪ*=Item.object_name=string
				System.out.println("ʼѡõϢ"+propInfo);
				String[] propConfigInfoArray= propInfo.split("=");
				String validPropName = null;//Ŀȥ*󣩵Чֵ
				if (propConfigInfoArray.length >= 3){
					String name = propConfigInfoArray[0];//ͼֽ͡
					System.out.println("ʼȡѡ["+name+"]Ϣ");
					String[] locationAndTruePropName = propConfigInfoArray[1].split("\\.");

					String trueName = locationAndTruePropName[1];//sb6_DRM03
					String type = propConfigInfoArray[2];//lov:SB6_TZLXLOV

					// prop Label
					if (name != null && name.contains("*")){
						validPropName = removeAsterisk(name);
						name = validPropName + "*";
					}
					validPropName = name;

					JLabel propLabel = new JLabel(name);
					GridBagConstraints gbcPropLabel = new GridBagConstraints();
					gbcPropLabel.gridx = 0;
					gbcPropLabel.gridy = propIndex;
					gbcPropLabel.anchor = GridBagConstraints.WEST;
					gbcPropLabel.insets = new Insets(5, 5, 5, 5);
					centerPanel1.add(propLabel, gbcPropLabel);

					// prop value
					if (type != null){
						String[] ss = type.split(":");//{"lov","SB6_TZLXLOV"}
						String lovName = null;
						String typeValue = ss[0];
						if (ss.length == 2) {
							lovName = ss[1];
						}
						if (typeValue.equals("string")){
							JTextField propTextField = new JTextField();

							GridBagConstraints gbcPropCombo = new GridBagConstraints();
							gbcPropCombo.gridx = 1;
							gbcPropCombo.gridy = propIndex;
							gbcPropCombo.anchor = GridBagConstraints.WEST;

							// Զ
							Dimension propValueSize = new Dimension(200, propTextField.getPreferredSize().height); // 200ΪĿ
							propTextField.setPreferredSize(propValueSize);

							centerPanel1.add(propTextField, gbcPropCombo);
							propComponentMap.put(validPropName, propTextField);
						}else if (typeValue.equals("date")){
							DateButton dateButton = new DateButton(null, "yyyy-MM-dd", false, false, false);

							GridBagConstraints gbcPropCombo = new GridBagConstraints();
							gbcPropCombo.gridx = 1;
							gbcPropCombo.gridy = propIndex;
							gbcPropCombo.anchor = GridBagConstraints.WEST;

							// Զ
							Dimension propValueSize = new Dimension(200, dateButton.getPreferredSize().height); // 200ΪĿ
							dateButton.setPreferredSize(propValueSize);
							
							centerPanel1.add(dateButton, gbcPropCombo);
							propComponentMap.put(validPropName, dateButton);
						} else if (typeValue.equals("lov")) {
							// ðźLOVƻȡlovֵװӵpropComboBox
							if (lovName == null) {
								System.out.println("δȡ["+name+"]õlovƣ!");
								return null;
							}
							LovProperty lovProperty = new LovProperty();//Զlov͵ࣺlov͵Ϣ
							TCComponentListOfValues unitLov = TCLOVUtil.findLOVByName(tcSession, lovName);
							String lovType = null;
							if(unitLov != null){
								lovType = unitLov.getType();
								if (lovType != null && lovType.equals("ListOfValuesString")) {//ͳlovkey-value
									System.out.println("ȡ["+name+"]LOVΪtraditional LOV");
									rMap.clear();
									Map<String, String> lovMap = getLOVDisplay_value(tcSession, lovName);
									lovProperty.setLovMap(lovMap);
									lovProperty.setLovType("LOV");
								} else if (lovType != null && lovType.equals("Fnd0ListOfValuesDynamic")) {//̬lov
									System.out.println("ȡ["+name+"]LOVΪdynamic LOV");
									String[] dynamicLOV = getDynamicLOV(unitLov);
									lovProperty.setLovType("DLOV");
									List<String> dlovList = new ArrayList<>();
									for (int i1 = 0; i1 < dynamicLOV.length; i1++) {
										dlovList.add(dynamicLOV[i1]);
									}
									lovProperty.setDlovList(dlovList);
								}else {
									System.out.println("ȡ["+name+"]LOVΪδ֪");
								}
							}else {
								continue;
							}

							lovProperty.setPropName(name);
							lovProperty.setPropTrueName(trueName);
							lovProperty.setLov(true);
							
							this.lovPropertyList.add(lovProperty);
							
							//lovͣȾͬlov
							if (lovType.equals("ListOfValuesString")) {
								DefaultMutableTreeNode root = generateLovTreeNode(lovProperty.getLovMap(),rMap);
								JTreeComboBox propComboBox = null;
								if(root != null) {
									propComboBox = new JTreeComboBox(root);
									GridBagConstraints gbcPropCombo = new GridBagConstraints();
									gbcPropCombo.gridx = 1;
									gbcPropCombo.gridy = propIndex;
									gbcPropCombo.anchor = GridBagConstraints.WEST;

									// Զ
									Dimension propValueSize = new Dimension(200, propComboBox.getPreferredSize().height); // 200ΪĿ
									propComboBox.setPreferredSize(propValueSize);

									centerPanel1.add(propComboBox, gbcPropCombo);
									propComponentMap.put(validPropName, propComboBox);
								}else {
									System.out.println("ƶlovʧܣ");
									continue;
								}
							}else {
								String[] dlov = lovProperty.getDlovList().toArray(new String[0]);
								
								JComboBox<String> jComboBox = new JComboBox<String>(dlov);
										
								GridBagConstraints gbcPropCombo = new GridBagConstraints();
								gbcPropCombo.gridx = 1;
								gbcPropCombo.gridy = propIndex;
								gbcPropCombo.anchor = GridBagConstraints.WEST;

								// Զ
								Dimension propValueSize = new Dimension(200, jComboBox.getPreferredSize().height); // 200ΪĿ
								jComboBox.setPreferredSize(propValueSize);

								centerPanel1.add(jComboBox, gbcPropCombo);
								propComponentMap.put(validPropName, jComboBox);
							}
							
						}
						propIndex ++;
					}else {
						System.out.println("ѡõ["+name+"]ϢУδȷͣ");
					}
				}else {
					System.out.println("ѡ["+preferenceName+"]øʽȷ飡");
				}
			}
		}else {
			System.out.println("δҵѡͶӦѡѡSB6_Create_LS_DesignǷȷ");
		}

		//2.ť
		this.closeButton = new JButton("ر");
		buttomPanel1.add(closeButton);
		this.buildButton = new JButton("½");
		buttomPanel1.add(buildButton);

		//ť¼
		this.closeButton.addActionListener(this);
		this.buildButton.addActionListener(this);

		frame.add(centerPanel1, BorderLayout.CENTER);
		frame.add(buttomPanel1, BorderLayout.SOUTH);

		frame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		frame.setResizable(true);
		frame.setPreferredSize(new Dimension(800,600));
		frame.pack(); // ԶڴСӦڲ

		//ŵĻ
		UIUtilities.centerToScreen(this);

		frame.setVisible(true);
		this.revalidate();
		this.repaint();
		
		this.buildFram = frame;
		
		return frame;

	}



	/**
	 * 
	 * @param lovMap lovһ<ʾֵ-ʵֵ>Map
	 * @param rMap2  һlov<ʵֵ>Ӧlov
	 * @return
	 */
	private DefaultMutableTreeNode generateLovTreeNode(Map<String, String> lovMap, Map<String, Map<String, String>> rMap2) {
		// ĸڵ
		DefaultMutableTreeNode root = new DefaultMutableTreeNode(" ");

		// ΪÿLOV
		for (Map.Entry<String, String> entry : lovMap.entrySet()) {
			DefaultMutableTreeNode subTree = createLovSubTree(entry.getKey(), entry.getValue(), rMap2);
			root.add(subTree);
		}

		return root;
	}
	/**
	 * ݹ鴴LOV
	 */
	private DefaultMutableTreeNode createLovSubTree(String displayValue, String realValue, Map<String, Map<String, String>> rMap2) {
		// ǰڵ
		DefaultMutableTreeNode node = new DefaultMutableTreeNode(displayValue);

		// ȡǰڵӽڵ
		Map<String, String> childLovMap = rMap2.get(realValue);

		if (childLovMap != null && !childLovMap.isEmpty()) {
			// Ϊÿӽڵݹ鴴
			for (Map.Entry<String, String> childEntry : childLovMap.entrySet()) {
				DefaultMutableTreeNode childNode = createLovSubTree(childEntry.getKey(), childEntry.getValue(), rMap2);
				node.add(childNode);
			}
		}

		return node;
	}
	
	/**
	 * ȡ̬LOVֵ
	 * @param lov LOV
	 * @return LOVѡ
	 */
	public String[] getDynamicLOV(TCComponentListOfValues lov) throws Exception {
	    Vector<String> lovDisplayValueList = new Vector<>();
//		lovDisplayValueList.add("");
//		Vector<String> lovValueList = new Vector<>();
	    com.teamcenter.services.rac.core.LOVService lovService = LOVService.getService(tcSession);
	    InitialLovData input = new InitialLovData();
	    LovFilterData filter = new LovFilterData();
	    filter.sortPropertyName = "object_name";
	    filter.order = 1;
	    filter.numberToReturn = 100;
	    filter.maxResults = 100;

	    input.lov = lov;
	    input.filterData = filter;
	    LOVSearchResults result = lovService.getInitialLOVValues(input);
	    for (LOVValueRow row : result.lovValues) {
	        Map<String, String[]> map = row.propDisplayValues;
//			Map<String, String[]> realmap = row.propInternalValues;
	        for (String key : map.keySet()) {
	            lovDisplayValueList.add(map.get(key)[0]);
//				lovValueList.add(realmap.get(key)[0]);
	        }
	    }
	    return lovDisplayValueList.toArray(new String[lovDisplayValueList.size()]);
	}



	/**
	 * ѡж(ҵ߼)ȡIDеĬֵ
	 * @param selectComponent2 ѡж
	 * @return IDеĬֵ
	 * @throws TCException 
	 */
	private String getIdValue(InterfaceAIFComponent selectComponent2) throws TCException {
//		String idValue = "";
		
		if(selectComponent2 instanceof TCComponentItemRevision){
			System.out.println("ǰѡжǰ汾󣬿ʼȡIDֵ");
			TCComponentItemRevision itemRevision = (TCComponentItemRevision) selectComponent2;
			String idValue = itemRevision.getStringProperty("item_id");
			if (idValue != null && !idValue.equals("")){
				return idValue.replace("_","");
			}else {{
				return null;//ȡ汾IDʧ
			}}
		}else if (selectComponent2 instanceof TCComponentFolder) {
			System.out.println("ǰѡжļж󣬴IDֵÿ");
			return "";
		}else {
			return  null;
		}
	}

	/**
	 * ȥַеǺ *
	 */
	public String removeAsterisk(String str) {
		if (str == null || str.isEmpty()) {
			return "";
		}

		// 滻е * 
		return str.replaceAll("\\*", "");
	}


	/**
	 * TC LOVֵʾֵ-ʵֵ
	 * @param seesion
	 * @param lovProp lov / ʵֵ 
	 * @return һlov<ʾֵ-ʵֵ>
	 * @throws TCException
	 */
	public static Map<String, String> getLOVDisplay_value(TCSession seesion,String lovProp) throws TCException
	{
		Map<String, String> Display_values = new HashMap<String, String>();
		
		TCComponentListOfValues unitLov = TCLOVUtil.findLOVByName(seesion, lovProp);
		if(unitLov != null){
			String[] realval = unitLov.getListOfValues().getStringListOfValues();

			String value="";
			boolean flag = false;
		    for (int i = 0; i < realval.length; i++) {			    	
		    	String disval = unitLov.getListOfValues().getDisplayableValue(realval[i]);
		    	Display_values.put(disval, realval[i]);
		    	//ݹ飺lovʵֵΪlovƣȡlovʾֵ-ʵֵ
				Map<String, String> lovDisplay_value = getLOVDisplay_value(seesion, realval[i]);
				
		     }
		}else {
//			System.out.println("δҵLOV=["+lovProp+"]lov");
		}
		if (!Display_values.isEmpty()){
			rMap.put(lovProp, Display_values);
		}

		return Display_values;
	}
	

}
